﻿/*
 * Author: G. Monz (DK7IO), 2012-04-29
 * This file is distributed without any warranty.
 * */

using System;
using System.IO;
using System.Drawing;

namespace RadioMobile
{
	public class RMUnit
	{
		Single _longitude = (Single)(0);
		public Single Longitude //Degrees
		{
			get
			{
				return _longitude;
			}
			set
			{
				_longitude = value;
			}
		}

		Single _latitude = (Single)(0);
		public Single Latitude //Degrees
		{
			get
			{
				return _latitude;
			}
			set
			{
				_latitude = value;
			}
		}

		Single _elevation = (Single)(0);
		public Single Elevation //m
		{
			get
			{
				return _elevation;
			}
			set
			{
				_elevation = value;
			}
		}

		bool _enabled = true;
		public bool Enabled
		{
			get
			{
				return _enabled;
			}
			set
			{
				_enabled = value;
			}
		}

		bool _transparent = false;
		public bool Transparent
		{
			get
			{
				return _transparent;
			}
			set
			{
				_transparent = value;
			}
		}

		bool _locked = false;
		public bool Locked
		{
			get
			{
				return _locked;
			}
			set
			{
				_locked = value;
			}
		}

		Int32 _foreColor = Utilities.GetColorNumber(Color.White);
		public Int32 ForeColor //0...16777215
		{
			get
			{
				return _foreColor;
			}
			set
			{
				_foreColor = value;
			}
		}

		Int32 _backColor = Utilities.GetColorNumber(Color.Black);
		public Int32 BackColor //0...16777215
		{
			get
			{
				return _backColor;
			}
			set
			{
				_backColor = value;
			}
		}

		String _name;
		public String Name //Length:=20
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		public RMUnit()
		{
		}

		public RMUnit(string name)
			: this()
		{
			Name = name;
		}

		public void Save(BinaryWriter binaryWriter)
		{
			binaryWriter.Write(Longitude);
			binaryWriter.Write(Latitude);
			binaryWriter.Write(Elevation);
			binaryWriter.Write(Utilities.ParseInt16(Enabled));
			binaryWriter.Write(Utilities.ParseByte(Transparent));
			binaryWriter.Write(Utilities.ParseByte(Locked));
			binaryWriter.Write(ForeColor);
			binaryWriter.Write(BackColor);
			binaryWriter.Write(Utilities.PadRight(Name, 20, true));
		}
	}
}